# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jboss/messaging/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free

%define reltag  SP3_CP01

Summary:        Enterprise Messaging for Java and the App Server
URL:            http://labs.jboss.com/jbossmessaging/
# svn export http://anonsvn.jboss.org/repos/messaging/tags/JBossMessaging_1_4_0_SP3_CP01/ jboss-messaging
# tar czf jboss-messaging-1.4.0.SP3_CP01-src.tar.gz jboss-messaging
Source0:        jboss-messaging-1.4.0.SP3_CP01-src.tar.gz
Source1:	    jboss-messaging-component-info.xml
Source2:        %{name}-libraries.ent

Name:           jboss-messaging
Version:        1.4.0
Release:        1.SP3_CP01.0jpp.ep1.1%{?dist}
Epoch:          0
License:        LGPL
Group:          Development/Java
BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-nodeps

BuildRequires: concurrent
BuildRequires: dom4j
BuildRequires: dtdparser
BuildRequires: eclipse-ecj
BuildRequires: gnu-trove
BuildRequires: hsqldb
BuildRequires: jakarta-commons-el
BuildRequires: jakarta-commons-logging
BuildRequires: jakarta-commons-modeler
BuildRequires: javacc3
BuildRequires: javassist
BuildRequires: jboss-aop
BuildRequires: jbossas
BuildRequires: jboss-common
BuildRequires: jboss-profiler
BuildRequires: jboss-remoting
BuildRequires: jboss-serialization
BuildRequires: jbossts
BuildRequires: jbossxb
BuildRequires: jgroups
BuildRequires: junit
BuildRequires: log4j
BuildRequires: qdox
BuildRequires: snmptrapappender
BuildRequires: tomcat5-admin-webapps
BuildRequires: tomcat5-common-lib
BuildRequires: tomcat5-jasper
BuildRequires: tomcat5-server-lib
BuildRequires: xerces-j2
BuildRequires: xml-commons-jaxp-apis
BuildRequires: xml-commons-resolver

Requires:      jpackage-utils >= 0:1.6
Requires:      concurrent
Requires:      jboss-aop
Requires:      jboss-common
Requires:      jboss-remoting
Requires:      jgroups

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
JBoss Messaging is a high performance JMS provider in the JBoss Enterprise 
Middleware Stack (JEMS). It is a complete rewrite of JBossMQ, the legacy 
JBoss JMS provider.

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}

%package demo
Summary:        Usage examples for %{name}
Group:          Development/Documentation

%description demo
%{summary}

%prep
%setup -q -n %{name}
chmod -R go=u-w *
#for j in $(find . -name "*.jar"); do
#    mv $j $j.no
#done

sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' %{SOURCE1}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE1}

%build
mkdir thirdparty

pushd thirdparty
mkdir -p apache-log4j/lib
ln -s $(build-classpath log4j) apache-log4j/lib/log4j.jar

mkdir -p apache-logging/lib
ln -s $(build-classpath commons-logging) apache-logging/lib/commons-logging.jar

mkdir -p apache-modeler/lib
ln -s $(build-classpath commons-modeler) apache-modeler/lib/commons-modeler.jar

mkdir -p apache-tomcat/lib
ln -s $(build-classpath tomcat5/catalina) apache-tomcat/lib/catalina.jar
ln -s $(build-classpath tomcat5/catalina-manager) apache-tomcat/lib/catalina-manager.jar
ln -s $(build-classpath tomcat5/catalina-optional) apache-tomcat/lib/catalina-optional.jar
ln -s $(build-classpath jasper5-compiler) apache-tomcat/lib/jasper-compiler.jar
ln -s $(build-classpath jdtcore) apache-tomcat/lib/jasper-compiler-jdt.jar
ln -s $(build-classpath jasper5-runtime) apache-tomcat/lib/jasper-runtime.ja
ln -s $(build-classpath tomcat5/naming-resources) apache-tomcat/lib/naming-resources.jar
ln -s $(build-classpath tomcat5/servlets-default) apache-tomcat/lib/servlets-default.jar
ln -s $(build-classpath tomcat5/servlets-invoker) apache-tomcat/lib/servlets-invoker.jar
ln -s $(build-classpath tomcat5/servlets-webdav) apache-tomcat/lib/servlets-webdav.jar
ln -s $(build-classpath tomcat5/tomcat-ajp) apache-tomcat/lib/tomcat-ajp.jar
ln -s $(build-classpath tomcat5/tomcat-apr) apache-tomcat/lib/tomcat-apr.jar
ln -s $(build-classpath tomcat5/tomcat-coyote) apache-tomcat/lib/tomcat-coyote.jar
ln -s $(build-classpath tomcat5/tomcat-http) apache-tomcat/lib/tomcat-http.jar
ln -s $(build-classpath tomcat5/tomcat-util) apache-tomcat/lib/tomcat-util.jar

mkdir -p apache-xerces/lib
ln -s $(build-classpath xerces-j2) apache-xerces/lib/xercesImpl.jar

mkdir -p apache-xml-commons/lib
ln -s $(build-classpath xml-commons-resolver) apache-xml-commons/lib/resolver.jar
ln -s $(build-classpath xml-commons-apis) apache-xml-commons/lib/xml-apis.jar

mkdir -p commons-el/lib
ln -s $(build-classpath commons-el) commons-el/lib/commons-el.jar

mkdir -p dom4j/lib
ln -s $(build-classpath dom4j) dom4j/lib/dom4j.jar

mkdir -p hsqldb/lib
ln -s $(build-classpath hsqldb) hsqldb/lib/hsqldb.jar

mkdir -p javassist/lib
ln -s $(build-classpath javassist) javassist/lib/javassist.jar
#javassist/lib/javassist-src.jar

mkdir -p jboss/aop/lib
#./jboss/aop/lib/common-softvaluehashmap.jar
ln -s $(build-classpath jboss-aop/jboss-aop) jboss/aop/lib/jboss-aop.jar
ln -s $(build-classpath jboss-aop/jboss-aop-jdk50-client) jboss/aop/lib/jboss-aop-jdk50-client.jar
ln -s $(build-classpath jboss-aop/jboss-aop-jdk50) jboss/aop/lib/jboss-aop-jdk50.jar
ln -s $(build-classpath jboss-aop/jdk14-pluggable-instrumentor) jboss/aop/lib/jdk14-pluggable-instrumentor.jar
ln -s $(build-classpath jboss-aop/jrockit-pluggable-instrumentor) jboss/aop/lib/jrockit-pluggable-instrumentor.jar
ln -s $(build-classpath jboss-aop/pluggable-instrumentor) jboss/aop/lib/pluggable-instrumentor.jar

mkdir -p jbossas/core-libs/lib
ln -s $(build-classpath jboss-common/jboss-common) jbossas/core-libs/lib/jboss-common.jar
ln -s $(build-classpath jbossas/jboss-common-jdbc-wrapper) jbossas/core-libs/lib/jboss-common-jdbc-wrapper.jar
ln -s $(build-classpath jbossas/jbosscx-client) jbossas/core-libs/lib/jbosscx-client.jar
ln -s $(build-classpath jbossas/jboss-j2ee) jbossas/core-libs/lib/jboss-j2ee.jar
ln -s $(build-classpath jbossas/jboss) jbossas/core-libs/lib/jboss.jar
ln -s $(build-classpath jbossas/jboss-jca) jbossas/core-libs/lib/jboss-jca.jar
ln -s $(build-classpath jbossas/jboss-jmx) ./jbossas/core-libs/lib/jboss-jmx.jar
#./jbossas/core-libs/lib/jboss-local-jdbc.jar
ln -s $(build-classpath jbossas/jbosssx-client) jbossas/core-libs/lib/jbosssx-client.jar
ln -s $(build-classpath jbossas/jboss-system) jbossas/core-libs/lib/jboss-system.jar
ln -s $(build-classpath jbossas/jboss-transaction-client) jbossas/core-libs/lib/jboss-transaction-client.jar
ln -s $(build-classpath jboss/jboss-xml-binding) jbossas/core-libs/lib/jboss-xml-binding.jar
#./jbossas/core-libs/lib/jms-ra.jar
ln -s $(build-classpath jbossas/jnp-client) jbossas/core-libs/lib/jnp-client.jar

mkdir -p jboss/common/lib
ln -s $(build-classpath jboss-common/jboss-common-client) jboss/common/lib/jboss-common-client.jar
ln -s $(build-classpath jboss-common/jboss-common) jboss/common/lib/jboss-common.jar
#./jboss/common/lib/jboss-common-sources.jar
ln -s $(build-classpath jboss-common/namespace) jboss/common/lib/namespace.jar

mkdir -p jboss/jbossts14/lib
ln -s $(build-classpath jbossts/jbossjta-integration) jboss/jbossts14/lib/jbossjta-integration.jar
ln -s $(build-classpath jbossts/jbossjta) jboss/jbossts14/lib/jbossjta.jar
ln -s $(build-classpath jbossts/jbossts-common) jboss/jbossts14/lib/jbossts-common.jar

mkdir -p jboss/jbossxb/lib
ln -s $(build-classpath jboss/jboss-xml-binding) jboss/jbossxb/lib/jboss-xml-binding.jar
#./jboss/jbossxb/lib/jboss-xml-binding-sources.jar

mkdir -p jboss/profiler/jvmti/lib
ln -s $(build-classpath jboss-profiler/jboss-profiler-jvmti) jboss/profiler/jvmti/lib/jboss-profiler-jvmti.jar

mkdir -p jboss/remoting/lib
ln -s $(build-classpath jboss-remoting) jboss/remoting/lib/jboss-remoting.jar

mkdir -p jboss/serialization/lib
ln -s $(build-classpath jboss-serialization) jboss/serialization/lib/jboss-serialization.jar

mkdir -p jgroups/lib
ln -s $(build-classpath jgroups) jgroups/lib/jgroups.jar

mkdir -p junit/lib
ln -s $(build-classpath junit) junit/lib/junit.jar

mkdir -p oswego-concurrent/lib
ln -s $(build-classpath concurrent) oswego-concurrent/lib/concurrent.jar

mkdir -p qdox/lib
ln -s $(build-classpath qdox) qdox/lib/qdox.jar

mkdir -p snmptrapappender/lib
ln -s $(build-classpath snmpTrapAppender) snmptrapappender/lib/snmpTrapAppender.jar

mkdir -p sun-javacc/lib
ln -s $(build-classpath javacc3) sun-javacc/lib/javacc.jar

mkdir -p trove/lib
ln -s $(build-classpath trove) trove/lib/trove.jar

mkdir -p wutka-dtdparser/lib
ln -s $(build-classpath dtdparser) wutka-dtdparser/lib/dtdparser.jar

popd

cp %{SOURCE2} thirdparty/libraries.ent

ant release-bundle

mkdir temp
pushd temp
tar xzf %{SOURCE0}
jar cf ../%{name}-src.jar *
popd temp
rm -rf temp

%install
rm -rf $RPM_BUILD_ROOT

# jar
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 0644 output/lib/jboss-messaging.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# client and sar
install -dm 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -pm 0644 output/lib/jboss-messaging-client.jar $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -pm 0644 output/lib/jboss-messaging.sar $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr output/etc $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr output/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -d -m 0755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr output/docs/userguide/en/pdf  $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr output/docs/userguide/en/html $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-messaging.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/jboss-messaging-client.jar $RPM_BUILD_ROOT%{repodirlib}
        # Add the source again for some eclipse jboss project use
	install -m 755 %{name}-src.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-messaging-src.jar
        # Add resources
        install -d -m 755 $RPM_BUILD_ROOT%{repodir}/resources
        cp -p output/etc/server/default/deploy/*.xml $RPM_BUILD_ROOT%{repodir}/resources
        rm $RPM_BUILD_ROOT%{repodir}/resources/multiplexer*
        rm $RPM_BUILD_ROOT%{repodir}/resources/jboss*
        cp -p output/etc/remoting/*.xml $RPM_BUILD_ROOT%{repodir}/resources
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -sf %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(-,root,root,-)
%dir %{_javadir}
%{_javadir}/*jar
%{_datadir}/%{name}-%{version}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Thu Dec 13 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-1.SP3_CP01.0jpp.ep1.1
- Upgrade to SP3_CP01

* Thu Dec 13 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-1.SP3.0jpp.ep1.1
- Upgrade to SP3

* Thu Dec 13 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-1.SP2.0jpp.ep1.4
- Accept JBoss Remoting 2.2.2.SP4

* Fri Dec 07 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-1.SP2.0jpp.ep1.3
- Accept JBoss Common 1.2.1.GA

* Fri Dec 07 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-1.SP2.0jpp.ep1.2
- Fix the set of files in resources
- Update component-info.xml with  list of such files

* Fri Dec 07 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-1.SP2.0jpp.ep1.1
- Update to SP2
- Add resources subdirectory to the repolib

* Wed Oct 31 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-1.SP1.0jpp.ep1.1
- Update to SP1

* Wed Oct 24 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-0jpp.ep1.1
- Fix release number
- Add client JAR to repolib as well

* Wed Oct 24 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-2jpp.ep1.1
- Upgrade to GA

* Thu Aug 30 2007 Deepak Bhole <dbhole@redhat.com> 0:1.4.0-1.CR1.0jpp.ep1.2
- Use the new javacc rpm
- Create a -src.jar

* Tue Aug 28 2007 Deepak Bhole <dbhole@redhat.com> 0:1.4.0-1.CR1.0jpp.ep1.1
- Initial build
